<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE hibernate-mapping PUBLIC "-//Hibernate/Hibernate Mapping DTD 3.0//EN"
        "http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd">
<hibernate-mapping>
    <class dynamic-insert="false" dynamic-update="false" lazy="true"
           name="org.adullact.iparapheur.repo.notification.Notification"
           proxy="org.adullact.iparapheur.repo.notification.Notification"
           select-before-update="false"
           table="ipa_notifications">
        <id column="uuid" name="uuidString" type="string" length="36">
        </id>
        <property name="payload" type="serializable">
            <column name="payload" sql-type="MEDIUMBLOB"/>
        </property>
        <property column="timestamp" name="timestamp" type="long"/>
        <property column="modifiedTimestamp" name="modifiedTimestamp" type="long"/>
        <property column="username" name="username" type="string"/>
        <property column="readValue" name="read" type="boolean"/>

    </class>

    <!-- Returns the notifications for the username -->
    <query cacheable="false" name="notifications.GetNotificationsForUser">
        select
        notification
        from
        Notification as notification
        where
        notification.username = :username
    </query>

    <query cacheable="false" name="notifications.GetUnreadNotificationsForUser">
        select
        notification
        from
        Notification as notification
        where
        notification.username = :username and notification.read = false
    </query>

    <query cacheable="false" name="notifications.GetNotificationForUserAndUUID">
        select
        notification
        from
        Notification as notification
        where
        notification.username = :username and notification.uuidString = :uuidString
    </query>

</hibernate-mapping>
